#include <bits/stdc++.h>
using namespace std;

#define fwd(i, a, n) for (int i = (a); i < (n); i ++)
#define rep(i, n) fwd(i, 0, n)
#define all(X) begin(X), end(X)
#define sz(X) ((int)X.size())
#define st first
#define nd second
#define pii pair<int, int>
#define vi vector<int>
#define ll long long
#define pll pair<long long, long long>

#ifdef LOC
auto &operator<<(auto &out, pair<auto, auto> a) {
    return out << "(" << a.st << ", " << a.nd << ")";
}

auto &operator<<(auto &out, auto a) {
    out << "{";
    for (auto b : a)
        out << b << ", ";
    return out << "}";
}

void dump(auto... x) { ((cerr << x << ", "), ...) << '\n'; }
#define debug(x...) cerr << "[" #x "]: ", dump(x)
#else
#define debug(...) 0
#endif

typedef vector<bitset<400>> vb;

struct Maxclique {
    double limit = 0.025, pk = 0;
    struct Vertex {int i, d = 0; };
    typedef vector<Vertex> vv;
    vb e;
    vv V;
    vector<vi> C;
    vi qmax, q, S, old;
    void init(vv& r) {
        for (auto &v : r) v.d = 0;
        for (auto &v : r) for (auto j : r) v.d += e[v.i][j.i];
        sort(all(r), [](auto a, auto b) { return a.d > b.d; });
        int mxD = r[0].d;
        rep(i, sz(r)) r[i].d = min(i, mxD) + 1;
    }
    void expand(vv &R, int lev = 1) {
        S[lev] += S[lev - 1] - old[lev];
        old[lev] = S[lev - 1];
        while (sz(R)) {
            if (sz(q) + R.back().d <= sz(qmax)) return;
            q.push_back(R.back().i);
            vv T;
            for (auto v : R) if (e[R.back().i][v.i]) T.push_back({v.i});
            if (sz(T)) {
                if (S[lev] ++ / ++pk < limit) init(T);
                int j = 0, mxk = 1, mnk = max(sz(qmax) - sz(q) + 1, 1);
                C[1].clear(), C[2].clear();
                for (auto v : T) {
                    int k = 1; 
                    auto f = [&](int i) { return e[v.i][i]; };
                    while (any_of(all(C[k]), f)) k ++;
                    if (k > mxk) mxk = k, C[mxk + 1].clear();
                    if (k < mnk) T[j ++].i = v.i;
                    C[k].push_back(v.i);
                }
                if (j > 0) T[j - 1].d = 0;
                fwd(k, mnk, mxk + 1) for (int i : C[k])
                    T[j].i = i, T[j++].d = k;
                    expand(T, lev + 1);
            } else if (sz(q) > sz(qmax)) qmax = q;
            q.pop_back(), R.pop_back();
        }
    }
    vi maxClique() { init(V), expand(V); return qmax;}
    Maxclique(vb conn) : e(conn), C(sz(e) + 1), S(sz(C)), old(S) {
        rep(i, sz(e)) V.push_back({i});
    }
};

vi odp(const int N, const int R) {
    int n = N;
    ll r = R;
    vector<pair<pll, pll> > verts;
    ll najw = n * 1000;
    vi odpow = {N, R};
    rep(x, n + 1)
        rep(y, n + 1) {
            pll norm = {x, y};
            pll kek = {x * 1000, y * 1000};
            if (kek.st >= r && kek.st + r <= najw) {
            if (kek.nd >= r && kek.nd + r <= najw)
                verts.push_back(make_pair(norm, kek));
            }
        }
    if (sz(verts) == 0) {
        return odpow;
    }
    vb dupa(sz(verts)); 
    rep(i, sz(verts))
        rep(j, sz(verts))
            if (i != j) {
                ll xdif = verts[i].nd.st - verts[j].nd.st;
                ll ydif = verts[i].nd.nd - verts[j].nd.nd;
                ll dist = xdif * xdif + ydif * ydif;
                if (dist >= 4 * r * r) {
                    dupa[i][j] = 1;
                }
            }
    Maxclique mc(dupa);
    vi chuj = mc.maxClique();
    for (auto a : chuj) {
        odpow.push_back(verts[a].st.st);
        odpow.push_back(verts[a].st.nd);
    }
    return odpow;
}

ll conv(string s) {
    rep(i, 3)
        if (s[sz(s) - 1 - i] == '.')
            s.push_back('0');
    ll r = 0;
    string t;
    for (auto c : s)
        if (isdigit(c))
            t.push_back(c);
    r = stoi(t);
    return r;
}

void zapisz(vi x) {
    cout << "{";
    rep(i, sz(x)) {
        cout << x[i];
        if (i + 1 < sz(x))
            cout << ",";
    }
    cout << "},";
}

int32_t main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    cout << "vector<vi> ansy = {";
    for (int N = 1; N <= 20; N ++) {
        vi dupa = odp(N, N * 1000);
        zapisz(dupa);
        int LAST = N * 1000;
        while (true) {
            int L = 1;
            int R = LAST - 1;
            int OSTAT = -1;
            vi zapis;
            while (L <= R) {
                int mid = (L + R) / 2;
                vi xdd = odp(N, mid);
                if (sz(xdd) > sz(dupa)) {
                    OSTAT = mid;
                    zapis = xdd;
                    L = mid + 1;
                } else
                    R = mid - 1;
            }
            if (OSTAT == -1)
                break;
            dupa = zapis;
            zapisz(dupa);
            LAST = OSTAT;
            debug("ZROB ", N, sz(zapis) - 2);
        }
    }
    return 0;
}